#include <config.h>
#include <string.h>

void
th_encrypt(const unsigned char* in, unsigned char* out, int size, unsigned char key, const unsigned char step, int block, int limit)
{
	const unsigned char* iend = NULL;
	const unsigned char* ilimit = NULL;
	const unsigned char* ip = NULL;
	const unsigned char* irealend = in + size;
	unsigned int rest;

	rest = size % block;
	if (rest >= block / 4)
		rest = 0;
	rest += size % 2;
	size -= rest;

	for (iend = in + size, ilimit = in + limit; in < iend && in < ilimit; in += block) {
		int increment;
		if (iend - in < block)
			block = iend - in;
		increment = block / 2;
		if (block % 2)
			increment++;

		for (ip = in + block - 1; ip > in; ip -= 2) {
			*out = *ip ^ key;
			*(out + increment) = *(ip - 1) ^ ((key + step * increment));
			out++;
			key += step;
		}

		if (block % 2) {
			*out = *ip ^ key;
			key += step;
		}

		/* Increment key by step * (block / 2). */
		key += step * increment;
		/* Increment out by (block / 2). */
		out += increment;
	}

	if (in != irealend)
		memcpy(out, in, irealend - in);
}
